"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _helperModuleImports = require("@babel/helper-module-imports");

var CHAIN_ERROR = 'Lodash chain sequences are not supported by babel-plugin-elfin.';

function _default(babel) {
  var t = babel.types;
  return {
    name: 'elfin-glodash',
    visitor: {
      MemberExpression: {
        exit: function exit(path) {
          if (!path.hub) return;
          var file = path.hub.file;
          var node = path.node;
          var object = node.object; // 是以属性调用的形式使用 glodash.cloneDeep()

          if (object && object.name !== 'glodash') return;
          var property = node.property; // 是否自定义了 glodash 变量

          if (file.scope.getBinding('glodash') || !property) return; // module标示

          var propertyName = property.name; // 不支持chain的链式调用

          if (propertyName === 'chain') {
            throw path.buildCodeFrameError(CHAIN_ERROR);
          }

          (0, _helperModuleImports.addDefault)(path, "lodash/".concat(propertyName), {
            nameHint: propertyName
          });
          path.replaceWith(t.identifier("_".concat(propertyName)));
        }
      }
    }
  };
}

module.exports = exports.default;